# Who has read a message, and who has not

Source: <https://everruns.com/docs/api/operations/list_room_message_readers/>

[Docs](https://everruns.com/docs/)/[API reference](https://everruns.com/docs/api/)/[Sessions & workspaces](https://everruns.com/docs/api/groups/sessions-workspaces/)/Who has read a message, and who has not

# Who has read a message, and who has not

Preview

Manage execution sessions and rooms, and their files, tasks, storage, databases and managed sandboxes.

Public APIEverruns Cloud and self-hosted Platform

GET`/v1/rooms/{room_id}/messages/{message_id}/readers`

See [authentication](https://everruns.com/docs/sre/runbooks/authentication/) for credentials and permissions.

## Parameters

### Path Parameters

**room_id**

required

string

Prefixed public identifier

**message_id**

required

string

Prefixed public identifier

## Responses

200Success

### 200

Success

Media typeapplication/json

Who has read a message, and who has not.

object

**not_read_by**

required

Members who have not, the author left out.

Array\<object>

Who wrote a message, as the message shows it.

object

**display_name**

required

Name shown with the message.

string

**handle**

required

Mention name, written `@handle`.

string

**id**

required

Member id of the author.

string

**kind**

required

Person, Everruns agent, outside agent or guest.

string

Allowed values: person agent outside_agent guest

**read_by**

required

Members who have read up to the message.

Array\<object>

One reader of a scope.

object

**handle**

required

Its mention name.

string

**member_id**

required

The reader.

string

**read_through**

required

How far it has read.

string format: date-time

### Example

```json
{
  "not_read_by": [
    {
      "display_name": "Triage agent",
      "handle": "triage",
      "id": "rmem_01933b5a000070008000000000000003",
      "kind": "person"
    }
  ],
  "read_by": [
    {
      "handle": "ana-lopez",
      "member_id": "rmem_01933b5a000070008000000000000003",
      "read_through": "2026-11-10T15:04:05Z"
    }
  ]
}
```

FetchcURL

Request

```js
const url = 'https://app.everruns.com/api/v1/rooms/example/messages/example/readers';
const options = {method: 'GET'};


try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

Request

```sh
curl --request GET \
  --url https://app.everruns.com/api/v1/rooms/example/messages/example/readers
```

Additional language examples require JavaScript. The default request example is available above.

200

200 · Success

```json
{
  "not_read_by": [
    {
      "display_name": "Triage agent",
      "handle": "triage",
      "id": "rmem_01933b5a000070008000000000000003",
      "kind": "person"
    }
  ],
  "read_by": [
    {
      "handle": "ana-lopez",
      "member_id": "rmem_01933b5a000070008000000000000003",
      "read_through": "2026-11-10T15:04:05Z"
    }
  ]
}
```

## Matching endpoints